<script>
import { calculatorMixin } from '../../mixins';
import StepProgress from '~/components/common/step-progress-bar.vue';
import CostResults from '@/components/calculator/cost-results.vue';
import CalculatorInput from '@/components/calculator/input.vue';

export default {
  name: 'CostROICalculator',
  components: {
    StepProgress,
    CostResults,
    CalculatorInput,
  },
  mixins: [calculatorMixin],
  props: {
    costData: {
      type: Object,
      required: true,
      default: null,
    },
    costResultsData: {
      type: Object,
      required: true,
      default: null,
    },
    spendTooltip: {
      type: String,
      required: true,
      default: null,
    },
    tooltipData: {
      type: Object,
      required: true,
      default: null,
    },
    premiumFeatures: {
      type: Object,
      required: false,
      default: null,
    },
    ultimateFeatures: {
      type: Object,
      required: false,
      default: null,
    },
    steps: {
      type: Array,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      currentStep: 0,
      formData: {
        numberOfUsers: 100,
        numberOfMaintainers: 1,
        sourceCodeManagementSpend: 0,
        continuousIntegrationSpend: 0,
        continuousDeliverySpend: 0,
        registriesSpend: 0,
        agileProjectManagementSpend: 0,
        agilePortfolioManagementSpend: 0,
        applicationSecuritySpend: 0,
      },
    };
  },
  computed: {
    atLeastOneSpend() {
      // user must fill out at least one field within the annual spending portion of the form
      return (
        this.formData.sourceCodeManagementSpend > 0 ||
        this.formData.continuousIntegrationSpend > 0 ||
        this.formData.continuousDeliverySpend > 0 ||
        this.formData.registriesSpend > 0 ||
        this.formData.agileProjectManagementSpend > 0 ||
        this.formData.agilePortfolioManagementSpend > 0 ||
        this.formData.applicationSecuritySpend > 0
      );
    },
  },
};
</script>

<template>
  <article :class="`calculator ${currentStep == 2 && 'showing-results'}`">
    <div class="calculator-container">
      <StepProgress
        :steps="steps"
        :active="currentStep"
        @changeStep="selectStep"
      />
      <div class="form" aria-live="polite" @submit.prevent>
        <div v-show="currentStep == 0">
          <SlpTypography tag="h2" variant="body1-bold">
            {{ costData.people }}
          </SlpTypography>
          <div class="form-controls">
            <div class="form-control">
              <label for="numberOfUsers"
                >{{ costData.users }}
                <SlpTooltip
                  id="numberOfUsers"
                  position="top"
                  mode="click"
                  :text="tooltipData.numberOfUsers"
                  class="tooltip"
                  data-ga-name="info numberOfUsers"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="numberOfUsers"
                v-model.number="formData.numberOfUsers"
                min="1"
              />
            </div>
            <div class="form-control line-break">
              <label for="numberOfMaintainers"
                >{{ costData.maintainers }}
                <SlpTooltip
                  id="numberOfMaintainers"
                  position="top"
                  mode="click"
                  :text="tooltipData.numberOfMaintainers"
                  class="tooltip"
                  data-ga-name="info numberOfMaintainers"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="numberOfMaintainers"
                v-model.number="formData.numberOfMaintainers"
                min="0"
              />
            </div>
          </div>
          <button
            data-ga-name="money roi continue to next step"
            data-ga-location="money roi calculator landing"
            class="slp-btn primary"
            type="button"
            :disabled="
              formData.numberOfMaintainers < 0 || formData.numberOfUsers < 1
            "
            @click="nextStep"
          >
            {{ costData.nextStep }}
            <SlpIcon variant="product" name="arrow-right" />
          </button>
        </div>
        <div v-show="currentStep == 1">
          <SlpTypography tag="h2" variant="body1-bold">
            {{ costData.spendPerYear }}
          </SlpTypography>
          <div class="form-controls">
            <div class="form-control">
              <label for="sourceCodeManagement"
                >{{ costData.sourceCodeManagement }}
                <SlpTooltip
                  id="sourceCodeManagement"
                  position="top"
                  mode="click"
                  :text="tooltipData.sourceCodeManagement"
                  class="tooltip"
                  data-ga-name="info sourceCodeManagement"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="sourceCodeManagement"
                v-model.number="formData.sourceCodeManagementSpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
            <div class="form-control">
              <label for="agileProjectManagement"
                >{{ costData.agileProjectManagement
                }}<SlpTooltip
                  id="agileProjectManagement"
                  position="top"
                  mode="click"
                  :text="tooltipData.agileProjectManagement"
                  class="tooltip"
                  data-ga-name="info agileProjectManagement"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="agileProjectManagement"
                v-model.number="formData.agileProjectManagementSpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
            <div class="form-control">
              <label for="continuousIntegration"
                >{{ costData.continuousIntegration
                }}<SlpTooltip
                  id="continuousIntegration"
                  position="top"
                  mode="click"
                  :text="tooltipData.continuousIntegration"
                  class="tooltip"
                  data-ga-name="info continuousIntegration"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="continuousIntegration"
                v-model.number="formData.continuousIntegrationSpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
            <div class="form-control">
              <label for="agilePortfolioManagement"
                >{{ costData.apm
                }}<SlpTooltip
                  id="agilePortfolioManagement"
                  position="top"
                  mode="click"
                  :text="tooltipData.agilePortfolioManagement"
                  class="tooltip"
                  min="0"
                  data-ga-name="info agilePortfolioManagement"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="agilePortfolioManagementSpend"
                v-model.number="formData.agilePortfolioManagementSpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
            <div class="form-control">
              <label for="continuousDelivery"
                >{{ costData.continuousDelivery
                }}<SlpTooltip
                  id="continuousDelivery"
                  position="top"
                  mode="click"
                  :text="tooltipData.continuousDelivery"
                  class="tooltip"
                  min="0"
                  data-ga-name="info continuousDelivery"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="continuousDeliverySpend"
                v-model.number="formData.continuousDeliverySpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
            <div class="form-control">
              <label for="applicationSecurity"
                >{{ costData.applicationSecurity
                }}<SlpTooltip
                  id="applicationSecurity"
                  position="top"
                  mode="click"
                  :text="tooltipData.applicationSecurity"
                  class="tooltip"
                  min="0"
                  data-ga-name="info applicationSecurity"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="applicationSecurity"
                v-model.number="formData.applicationSecuritySpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
            <div class="form-control">
              <label for="registries"
                >{{ costData.registries
                }}<SlpTooltip
                  id="registries"
                  position="top"
                  mode="click"
                  :text="tooltipData.registries"
                  class="tooltip"
                  data-ga-name="info registries"
                  :data-ga-location="`cost-tab step ${currentStep + 1}`"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <CalculatorInput
                id="registries"
                v-model.number="formData.registriesSpend"
                :dollar-sign="true"
                min="0"
              />
            </div>
          </div>
          <button
            data-ga-name="money roi see your savings"
            data-ga-location="money roi calculator spending"
            class="slp-btn primary"
            type="button"
            :disabled="!atLeastOneSpend"
            @click="nextStep"
          >
            {{ costData.savings }}
            <SlpIcon variant="product" name="arrow-right" />
          </button>
        </div>
        <CostResults
          v-show="currentStep == 2"
          :form-data="formData"
          :cost-results="costResultsData"
          :premium-features="premiumFeatures"
          :ultimate-features="ultimateFeatures"
          :spend-tooltip="spendTooltip"
          v-on="$listeners"
        />
        <SlpButton
          v-if="currentStep > 0"
          href="/calculator/roi/"
          variant="secondary"
          class="slp-mt-16"
          data-ga-name="money roi restart calculator"
          data-ga-location="money roi restart calculator"
        >
          <SlpIcon
            name="clear-all"
            variant="product"
            hex-color="#171321"
            alt="Chevron Right Icon"
            class="slp-mr-8"
          />
          {{ costData.restart }}
        </SlpButton>
      </div>
    </div>
  </article>
</template>

<style lang="scss" scoped>
@import '../../assets/css/roi-calculators.scss';
</style>
